'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.StyledButton = undefined;

var _templateObject = _taggedTemplateLiteral(['        \n    height: ', ';\n    min-width: ', ';\n    width: ', ';\n    border-radius: ', ';\n    color: ', ';\n    border: ', ';\n    outline: none;\n    font-weight: ', ';\n    background: ', ';\n    box-shadow: ', ';\n    &:disabled {\n        cursor: default;   \n        border: none;\n        background: ', ';    \n    }\n    &:hover {\n        background: ', ';\n        box-shadow: ', ';\n        border: ', ';\n        color: ', ';\n        cursor: ', ';\n    }\n'], ['        \n    height: ', ';\n    min-width: ', ';\n    width: ', ';\n    border-radius: ', ';\n    color: ', ';\n    border: ', ';\n    outline: none;\n    font-weight: ', ';\n    background: ', ';\n    box-shadow: ', ';\n    &:disabled {\n        cursor: default;   \n        border: none;\n        background: ', ';    \n    }\n    &:hover {\n        background: ', ';\n        box-shadow: ', ';\n        border: ', ';\n        color: ', ';\n        cursor: ', ';\n    }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _colors = require('../../colors/colors');

var _colors2 = _interopRequireDefault(_colors);

var _polished = require('polished');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var StyledButton = exports.StyledButton = _styledComponents2.default.button(_templateObject, function (props) {
    return props.large ? '44px' : props.small ? '30px' : '40px';
}, function (props) {
    return props.width ? props.width + 'px' : props.large ? '220px' : props.small ? '110px' : '160px';
}, function (props) {
    return props.width && props.width + 'px';
}, function (props) {
    return props.large ? '40px' : '20px';
}, function (props) {
    return props.open ? _colors2.default[props.color] : '#fff';
}, function (props) {
    return props.open ? '2px solid ' + _colors2.default[props.color] : props.primary ? '1px solid ' + (0, _polished.darken)(0.05, _colors2.default.primary) : '1px solid ' + (0, _polished.darken)(0.05, _colors2.default[props.color]);
}, function (props) {
    return props.large || props.open && 600;
}, function (props) {
    return props.open ? 'none' : props.primary ? _colors2.default.primary : _colors2.default[props.color];
}, function (props) {
    return props.open || props.disabled ? 'none' : '0 1px 6px rgba(0,0,0,0.2)';
}, function (props) {
    return !props.pending && '#ccc';
}, function (props) {
    return props.open ? _colors2.default[props.color] : !props.disabled && !props.open && (0, _polished.darken)(0.05, props.primary ? _colors2.default.primary : _colors2.default[props.color]);
}, function (props) {
    return !props.disabled && !props.open && '0 2px 10px 1px rgba(0,0,0,0.3)';
}, function (props) {
    return props.open && '1px solid ' + (0, _polished.darken)(0.1, _colors2.default[props.color]);
}, function (props) {
    return props.open && '#fff';
}, function (props) {
    return !props.disabled && 'pointer';
});

var Button = function Button(_ref) {
    var _ref$type = _ref.type,
        type = _ref$type === undefined ? 'button' : _ref$type,
        primary = _ref.primary,
        url = _ref.url,
        disabled = _ref.disabled,
        _ref$pending = _ref.pending,
        pending = _ref$pending === undefined ? false : _ref$pending,
        _ref$color = _ref.color,
        color = _ref$color === undefined ? 'lightgrey' : _ref$color,
        open = _ref.open,
        defaultText = _ref.defaultText,
        pendingText = _ref.pendingText,
        large = _ref.large,
        small = _ref.small,
        width = _ref.width,
        onClick = _ref.onClick,
        style = _ref.style;

    if (url) {
        return _react2.default.createElement(
            _reactRouterDom.Link,
            { to: url, style: style },
            _react2.default.createElement(
                StyledButton,
                {
                    type: type,
                    onClick: onClick && onClick,
                    disabled: pending || disabled,
                    pending: pending,
                    primary: primary,
                    color: color,
                    open: open,
                    width: width,
                    small: small,
                    large: large,
                    style: style },
                pending ? pendingText : defaultText
            )
        );
    }

    return _react2.default.createElement(
        StyledButton,
        {
            type: type,
            onClick: onClick && onClick,
            disabled: pending || disabled,
            pending: pending,
            color: color,
            small: small,
            large: large,
            primary: primary,
            open: open,
            width: width,
            style: style },
        pending ? pendingText : defaultText
    );
};

Button.propTypes = {
    type: _propTypes2.default.string,
    defaultText: _propTypes2.default.string.isRequired,
    pendingText: _propTypes2.default.string,
    pending: _propTypes2.default.bool,
    open: _propTypes2.default.bool,
    flat: _propTypes2.default.bool,
    small: _propTypes2.default.bool,
    large: _propTypes2.default.bool,
    onClick: _propTypes2.default.func,
    color: _propTypes2.default.string,
    width: _propTypes2.default.number,
    style: _propTypes2.default.object,
    url: _propTypes2.default.string
};

exports.default = Button;