'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n    margin: 0 0 30px 0;\n    width: 100%;\n    border: none;    \n    padding:0;    \n'], ['\n    margin: 0 0 30px 0;\n    width: 100%;\n    border: none;    \n    padding:0;    \n']),
    _templateObject2 = _taggedTemplateLiteral(['\n    box-sizing: border-box;\n    border: 1px solid #b3b3b3;\n    border-radius:2;\n    margin:0;\n    box-shadow: none;\n    width: 100%;\n    height: 40px;\n    padding-left: 10px;\n    \n    &:focus {\n        border: 1px solid #5fb6c1;\n        box-shadow: 0 0 5px #5fb6c1;\n    }\n\n\n'], ['\n    box-sizing: border-box;\n    border: 1px solid #b3b3b3;\n    border-radius:2;\n    margin:0;\n    box-shadow: none;\n    width: 100%;\n    height: 40px;\n    padding-left: 10px;\n    \n    &:focus {\n        border: 1px solid #5fb6c1;\n        box-shadow: 0 0 5px #5fb6c1;\n    }\n\n\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../../icons/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var StyledFieldSet = _styledComponents2.default.fieldset(_templateObject);

var StyledInput = _styledComponents2.default.input(_templateObject2);

var TextInput = function TextInput(_ref) {
    var htmlId = _ref.htmlId,
        label = _ref.label,
        _ref$type = _ref.type,
        type = _ref$type === undefined ? "text" : _ref$type,
        _ref$maxLength = _ref.maxLength,
        maxLength = _ref$maxLength === undefined ? -1 : _ref$maxLength,
        info = _ref.info,
        name = _ref.name,
        value = _ref.value,
        onChange = _ref.onChange,
        error = _ref.error,
        placeholder = _ref.placeholder,
        _ref$required = _ref.required,
        required = _ref$required === undefined ? false : _ref$required,
        _ref$autoFocus = _ref.autoFocus,
        autoFocus = _ref$autoFocus === undefined ? 'false' : _ref$autoFocus,
        style = _ref.style;

    return _react2.default.createElement(
        StyledFieldSet,
        { style: style },
        _react2.default.createElement(
            _Label2.default,
            { htmlFor: htmlId, style: styles.label, label: label },
            info && _react2.default.createElement(_Icon2.default, {
                icon: 'info',
                defaultColor: '#fff',
                backgroundColor: '#ccc',
                round: true,
                width: 20,
                hoverText: info,
                style: styles.info
            })
        ),
        _react2.default.createElement(StyledInput, {
            autoComplete: 'off',
            type: type,
            id: htmlId,
            value: value,
            name: name,
            placeholder: placeholder,
            required: required,
            onChange: onChange,
            autoFocus: autoFocus,
            maxLength: maxLength }),
        error && _react2.default.createElement(
            'div',
            { className: 'form-error' },
            error
        )
    );
};

TextInput.propTypes = {
    htmlId: _react2.default.PropTypes.string,
    label: _react2.default.PropTypes.string.isRequired,
    type: _react2.default.PropTypes.string,
    name: _react2.default.PropTypes.string.isRequired,
    value: _react2.default.PropTypes.string.isRequired,
    onChange: _react2.default.PropTypes.func.isRequired,
    error: _react2.default.PropTypes.string,
    placeholder: _react2.default.PropTypes.string,
    required: _react2.default.PropTypes.bool,
    autoFocus: _react2.default.PropTypes.bool
};

var styles = {
    container: {
        marginBottom: 30,
        width: '100%'
    },
    // label: {
    //     color: '#333',
    //     margin: '0 2px 2px 0',
    //     display: 'flex'
    // },
    info: {
        marginLeft: 7,
        position: 'relative'
    },
    input: {
        border: '1px solid #b3b3b3',
        borderRadius: 2,
        marginTop: 0,
        boxShadow: 'none',
        width: '100%',
        ':focus': {
            border: '1px solid #5fb6c1',
            boxShadow: '0 0 5px #5fb6c1'
        }
    }
};

exports.default = (0, _radium2.default)(TextInput);